import { world, EquipmentSlot } from "@minecraft/server";

function lodestoneEffect(player) {
	player.playSound("mob.shulker.teleport");
	for (var i = 0; i < 32; i++) {
		player.runCommand("particle minecraft:mob_portal ~ ~1 ~")
	}
}

world.afterEvents.itemUseOn.subscribe(function (data) {
	if (data.block.typeId == "minecraft:lodestone") {
		if (data.itemStack.typeId == "minecraft:compass") {
			const player = data.source;
			const equippable = player.getComponent("equippable");
			const itemHand = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);
			itemHand.setDynamicProperty("coordinates", {x: data.block.x + 0.5, y: data.block.y + 1, z: data.block.z + 0.5});
			itemHand.setDynamicProperty("dimension", data.block.dimension.id);
		}

		if (data.itemStack.typeId == "minecraft:lodestone_compass") {
			const player = data.source;
			const equippable = player.getComponent("equippable");
			const itemHand = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);
			lodestoneEffect(player);
			player.teleport(itemHand.getDynamicProperty("coordinates"), {dimension: world.getDimension(itemHand.getDynamicProperty("dimension"))});
			lodestoneEffect(player);
		}
	}
});

world.beforeEvents.itemUseOn.subscribe(function (data) {
	if (data.itemStack.typeId == "minecraft:compass" && data.itemStack.amount > 1 && data.block.typeId == "minecraft:lodestone") {
		data.cancel = true;
		data.source.sendMessage("§5You can only check a lodestone with a single compass");
	}
});

